#!/bin/bash
# Petit test pour connaitre rapidement les sipX.youroute.net
# v 0.2
#Nicolas Bondier
#Switzernet

# Numbers of Sip server
N_SER=40

# Message final
FINISHED="Done"

# Calcul du nombre de colones du terminal
COLUMNS=$( tput cols )

# Calcul de la longueur de la barre de chargement
COLS=$((${COLUMNS} - ${#FINISHED} - 5))

max_lenght=0;

function multiecho() {
    for ((n=1; n<=$1; n++))
    do
		echo -n -e "$2"
    done
}

#Affichage info nslookup
echo ""
echo -e "\033[40m\033[1;37m Execution des nslookup...\033[0m"
echo ""

# Affichage min et max barre
echo -n "0"
multiecho $(($COLS-3)) " "
echo '100%'

# Affichage extrémités barre 
echo -n "|"
multiecho $COLS " "
echo -n "|"

# Boucle nslooup
for ((i=0; i<=$N_SER; i++))
do
	if [[ $i == 0 ]]
	then
		nslp=$(nslookup sip.youroute.net 2> /dev/null | grep Name | sed 's/Name\://')
		echo sip.youroute.net >> $nslp".sw_sip_list"
	else
		nslp=$(nslookup sip"$i".youroute.net 2> /dev/null | grep Name | sed 's/Name\://')
		echo sip$i.youroute.net >> $nslp".sw_sip_list"
	fi
	if [[ $max_lenght -lt ${#nslp} ]]; then
		max_lenght=${#nslp}
	fi
	PERCENTAGE=$(( $i * $COLS / $N_SER ))
	d=$(( $COLS + $PERCENTAGE ))
	echo -e -n "\033["$d"D|"
	multiecho $PERCENTAGE "="
	echo -n ">"
done
echo "| $FINISHED."

#Affichage final
for file in *.sw_sip_list
do	
	echo -n "
 +"
	multiecho $max_lenght "-"
	echo "+"
	name=$(echo $file | sed 's/.sw_sip_list//')
	ip=$(ping $name -n 1 2> /dev/null | grep "^PING" | sed -n 's/\([0-9]\{1,3\}\.\)\{3\}[0-9]\{1,3\}/\nIP : &\n/gp' | grep IP)
	echo -e -n " |\033[40m\033[0;31m$name\033[0m"
	multiecho $(($max_lenght - ${#name})) " "
	echo "|"
	
	echo -e -n " |\033[40m\033[0;36m$ip\033[0m"
	multiecho $(($max_lenght - ${#ip})) " "
	echo "|"
	
	echo -n " +"
	multiecho $max_lenght "-"
	echo "+"
	while read line  
	do
  		echo -e -n " | "$line
  		multiecho $(($max_lenght - ${#line} - 1)) " "
  		echo "|"
	done < $file
	echo -n " +"
	multiecho $max_lenght "-"
	echo "+"
done


rm *.sw_sip_list


#Nicolas Bondier
#Switzernet